# Installation
> `npm install --save @types/jquery-deserialize`

# Summary
This package contains type definitions for jquery-deserialize (https://github.com/kflorence/jquery-deserialize).

# Details
Files were exported from https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/jquery-deserialize.
## [index.d.ts](https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/jquery-deserialize/index.d.ts)
````ts
/// <reference types="jquery"/>

declare namespace JQueryDeserialize {
    interface DeserializeOptions<TElement> {
        change?(element: Element, value: any): void;
        complete?($elements: JQuery<TElement>): void;
        // the filter param is directly passed into JQuery.filter()
        // but the type declaration intended does not work
        // https://github.com/microsoft/TypeScript/issues/29732
        // filter? : Parameters<JQuery['filter']>[0];
        filter?: unknown;
    }
}

interface JQuery<TElement = HTMLElement> {
    deserialize(
        data: string,
        options?:
            | JQueryDeserialize.DeserializeOptions<TElement>
            | JQueryDeserialize.DeserializeOptions<TElement>["complete"],
    ): this;
}

````

### Additional Details
 * Last updated: Wed, 22 Nov 2023 19:35:44 GMT
 * Dependencies: [@types/jquery](https://npmjs.com/package/@types/jquery)

# Credits
These definitions were written by [Michael Tsang](https://github.com/miklcct).
